import papi, atexit

class SimpleAction (papi.AtkObject):
    def __init__ (self):
        papi.AtkObject.__init__ (self, papi.ATK_IFACE_ACTION)

        self._tracker = 0

        # Override the necessary interfaces.
        self.action_get_n_actions = self._get_n_actions
        self.action_get_description = self._get_description
        self.action_get_name = self._get_name
        self.action_do_action = self._do_action

    def _do_action (self, i):
        if i == 0:
            print "The first action was executed."
        if i == 1:
            print "Another action was executed."
        if i == 2:
            self._tracker += 1
            self.name = "Action with %d tracked executions" % self._tracker
            
    def _get_n_actions (self):
        return 3

    def _get_description (self, i):
        if i == 0:
            return "Prints a console message."
        if i == 1:
            return "Prints another console message."
        if i == 2:
            return "Modifies attributes."

    def _get_name (self, i):
        if i == 0:
            return "PrintMessage"
        if i == 1:
            return "PrintAnothreMessage"
        if i == 2:
            return "ChangeAttributes"
    
application = papi.AtkObject ()
application.name = "AtkAction Application"
application.description = "An AtkAction demonstration example."
application.role = papi.ATK_ROLE_APPLICATION

papi.set_atk_root (application)
atexit.register (papi.shutdown)
papi.init ()

action = SimpleAction ()
action.name = "Simple AtkAction"
action.description = "A simple AtkAction with three actions."
action.role = papi.ATK_ROLE_WINDOW
action.parent = application

print "Press CTRL-C to exit the application."
while True:
    papi.iterate ()
